﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp56
{
    public partial class Form1 : Form
    {
        delegate void mydel(String s);
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            for (int i = 1; i < 20; i++)
            {
                Thread.Sleep(500);
                label1.Text = i.ToString();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Thread t1 = new Thread(doSomething);
            t1.Start();
        }
        private void doSomething()
        {
            mydel d1 = changeLabel;
            for (int i = 1; i < 20; i++)
            {
                Thread.Sleep(500);
                label1.Invoke(d1,i.ToString()); 
            }
        }
        private void changeLabel(String s)
        {
            label1.Text = s;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Action a = doSomething;
            Task.Run(a);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Task.Run(() => doSomething()); //lambda expression!
        }
    }
}
